// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DynamicToolBar.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}


	// begin create dynamic tool bar
	if (!m_wndMyToolBar.CreateEx(this, TBSTYLE_FLAT /*| TBSTYLE_TRANSPARENT*/, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create dynamic toolbar\n");
		return -1;      // fail to create
	}

	CDC *dc = this->GetDC();
	CDC dcMem; 
	dcMem.CreateCompatibleDC(dc);

	HBITMAP hbitmap = CreateCompatibleBitmap(dc->m_hDC, 50*16, 16);

	CBitmap *bmp = CBitmap::FromHandle(hbitmap);

	CBitmap* pOldBitmap = dcMem.SelectObject( bmp );

	//draw a filled rectangle with the background (window) color 
	CRect rect(0, 0, 5*16, 16);
	FillRect(dcMem.m_hDC, &rect, (HBRUSH) (COLOR_WINDOW));

	dcMem.SetMapMode(MM_TEXT);

	CString tmp = "Button ";

	for (int i=0;i<5;i++) {
		
		HICON icon = LoadIcon(NULL,MAKEINTRESOURCE(32512+i));
		
		dcMem.DrawIcon( i*16, 0, icon );
		
		char buffer[2];

		m_wndMyToolBar.InsertToolTip( tmp + itoa(i,buffer,10));

	}

	dcMem.SelectObject(pOldBitmap); 
	dcMem.DeleteDC();
	pOldBitmap->DeleteObject();

	m_wndMyToolBar.SetBitmap(hbitmap);

	m_wndMyToolBar.SetButtons(NULL,i);

	for(int j=0; j<i; j++) {
				
		m_wndMyToolBar.SetButtonInfo(j, ID_MYTOOLBAR_BUTTON1 + j, TBBS_BUTTON | TBBS_AUTOSIZE, j);

	}

	// end	 create dynamic tool bar
 
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


void CMainFrame::GetMessageString(UINT nID, CString& rMessage) const
{
	if ((nID >= ID_MYTOOLBAR_BUTTON1) && (nID <= ID_MYTOOLBAR_BUTTONLAST))
		rMessage = (const_cast <CMyDynamicToolBar*> (&m_wndMyToolBar))
			->GetToolTip(nID);
	else
		CMDIFrameWnd::GetMessageString(nID, rMessage);

	return;
}
